#include <bits/stdc++.h>

using namespace std;

int n, m, k;

bool Check(int i1, int i2){
    int x1, x2, y1, y2;
    x1 = i1/(m+1-k); y1 = i1%(m+1-k);
    x2 = i2/(m+1-k); y2 = i2%(m+1-k);
    if (abs(x1-x2) < k && abs(y1-y2) < k) return false;
    return true;
}

int main(){
    vector <vector <int> > A, Sum;

    scanf("%d%d%d", &n, &m, &k);
    A.resize(n);
    for (int i = 0; i<n; i++){
        A[i].resize(m);
        for (int j = 0; j<n; j++) scanf("%d", &A[i][j]);
    }

    Sum.resize(1+n-k); for (int i = 0; i<n-k+1; i++) Sum[i].resize(m-k+1, 0);
    for (int i = 0; i<k; i++) for (int j = 0; j<k; j++) Sum[0][0] += A[i][j];

    for (int i = 0; i<n-k+1; i++) for (int j = 0; j<m-k+1; j++) if (i+j != 0){
        if (i == 0){
            Sum[i][j] = Sum[i][j-1];
            for (int t = 0; t<k; t++) Sum[i][j] += A[t][j+k-1]-A[t][j-1];
        } else {
            Sum[i][j] = Sum[i-1][j];
            for (int t = 0; t<k; t++) Sum[i][j] += A[i+k-1][j+t]-A[i-1][j+t];
        }
    }
/*
   for (int i = 0; i<Sum.size(); i++){
        for (int j = 0; j<Sum[i].size(); j++) printf("%d ", Sum[i][j]);
        printf("\n");
    }
*/
    vector <pair <int, int> > Rez;
    Rez.resize((n-k+1)*(m-k+1));
    for (int i = 0; i<n-k+1; i++) for (int j = 0; j<m-k+1; j++){
       Rez[i*(m-k+1)+j] = make_pair(Sum[i][j], i*(m-k+1)+j);
    }
    sort(Rez.begin(), Rez.end());
    for (int i = 0; i<Rez.size()/2; i++) swap(Rez[i], Rez[Rez.size()-1-i]);

   // for (int i = 0; i<Rez.size(); i++) printf("%d ", Rez[i].first);
    long long ans = -1, nowans;
    for (int i = 0; i<Rez.size()-2; i++){
        for (int j = i+1; Rez[i].first+Rez[j].first+Rez[j+1].first > ans; j++) if (Check(Rez[i].second, Rez[j].second)){
            int k = j+1;
            while (!Check(Rez[i].second, Rez[k].second) || !Check(Rez[k].second, Rez[j].second)) k++;
            nowans = Rez[i].first + Rez[j].first + Rez[k].first;
            if (ans == -1 || ans < nowans) ans = nowans;
        }
        if (Rez[i].first + Rez[i+1].first + Rez[i+2].first <= ans) break;
    }

    printf("%lld", ans);

    return 0;
}
/*
    int x1, y1, x2, y2, x3, y3;
    long long ans = 0, nowans;
    bool p;
    for (int i1 = 0; i1<(n+1-k)*(m+1-k); i1++) for (int i2 = i1; i2<(n+1-k)*(m+1-k); i2++) for (int i3 = i2; i3<(n+1-k)*(m+1-k); i3++){
        x1 = i1/(m+1-k); y1 = i1%(m+1-k);
        x2 = i2/(m+1-k); y2 = i2%(m+1-k);
        x3 = i3/(m+1-k); y3 = i3%(m+1-k);
        p = 1;
        if (x2 < x1+k && y2 < y1+k && y2 > y1-k) p = 0;
        if (x3 < x1+k && y3 < y1+k && y3 > y1-k) p = 0;
        if (x3 < x2+k && y3 < y2+k && y3 > y2-k) p = 0;
        if (p){
            nowans = Sum[x1][y1] + Sum[x2][y2] + Sum[x3][y3];
            if (nowans > ans) ans = nowans;
        }
    }

    printf("%lld", ans);

    return 0;
}
*/
