#include <iostream>
#include <algorithm>
#include <cstring>

using namespace std;

bool is_pref(string pref, string src) {
    int length = pref.length();
    int t = src.length();
    if (length > t) {
        return false;
    }
    for (int i = 0; i < length; ++ i) {
        if (pref[i] != src[i]) {
            return false;
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    pair<string, int> strs[n];
    for (int i = 0; i < n; ++ i) {
        string t;
        cin >> t;
        strs[i].first = t;
        strs[i].second = i + 1;
    }
    sort (strs, strs + n);
    for (int i = 0; i < m; ++ i) {
        int k, already_in_k = 0;
        string w;
        cin >> k >> w;
        for (int j = 0; j < n; ++ j) {
            if (!is_pref(w, strs[j].first)) {
                continue;
            }
            already_in_k ++;
            if (already_in_k == k) {
                cout << strs[j].second << endl;
                break;
            }
        }
        if (already_in_k != k) {
            cout << -1 << endl;
        }
    }
}
